# AVNI - Analysis and Visualization toolkit for plaNetary Inferences

<img
src="http://avni.globalseismology.org/stable/_static/logos/logo_avni_color_withname.png"
width="512">

## About

AVNI is a software ecosystem for analyzing and interpreting planetary models and
data sets that were initially designed or the three-dimensional reference Earth
model project [REM3D](http://rem3d.org). The codes are primary written in Python
with interfaces to legacy routines in C and Fortran. Some installation files as
well as applets and API access require registration on the AVNI Homepage below.

**ReadTheDocs**: [avni.globalseismology.org](http://avni.globalseismology.org)

**Source code**: [github](https://github.com/globalseismology/avni)

**Requests/Bug Reports**:
[issues](https://github.com/globalseismology/avni/issues)

**Contact**: **avni@globalseismology.org**

**Frequently Asked Questions**:
[FAQ](http://avni.globalseismology.org/stable/overview/faq.html)

A core team maintains the public repository and releases versions after
benchmarking; if you do not see activity on Github, that does not mean
improvements or bug fixes are not underway! We provide APIs that interface with
heavy, legacy codes hosted our servers so that AVNI installation remains light
to serve various applications. Contact the AVNI team at
**avni@globalseismology.org** with any questions or suggestions.

[![License: GPL
v3](https://img.shields.io/badge/License-GPLv3-blue.svg)](https://www.gnu.org/licenses/gpl-3.0)
[![PyPI
version](https://badge.fury.io/py/avni.svg)](https://badge.fury.io/py/avni)
![PyPI - Python
Version](https://img.shields.io/pypi/pyversions/avni.svg?style=popout)

## Requirements

AVNI needs the following python modules installed in the system.
  * The gfortran Fortran compiler
  * Python 3.7+

## Getting Started

These instructions will get you a copy of the project up and running on your
local machine for development and testing purposes. See deployment for notes on
how to deploy the project on a live system.


## Contributing to our software

AVNI is a community project that lives by the participation of its members —
i.e., including you! It is our goal to build an inclusive and participatory
community so we are happy that you are interested in participating! We have
collected a set of guidelines and advice on how to get involved in the community
and keep them in the [Contributing
Guide](http://avni.globalseismology.org/stable/overview/contributing.html).
Please follow the contributor covenant code of conduct specified in the
[CODE_OF_CONDUCT.md](CODE_OF_CONDUCT.md) in all interactions and deliberations.

## Authors

The *Principal Developers* that maintain AVNI are listed in [AUTHORS](AUTHORS).
See also the list of [Github
contributors](https://github.com/globalseismology/avni/contributors) who
participate in this project.

## Versioning

Current software version is provided in the file [version](avni/version.py)
file. We use [SemVer](http://semver.org/) for versioning as explained in our
[versioning
conventions](http://avni.globalseismology.org/stable/overview/versioning_conventions.html).
For the versions available, see the [tags on this
repository](https://github.com/globalseismology/avni/tags).

## License

This software is published under the GNU GPL v3 license - see the
[LICENSE](LICENSE) file for details. Please write to
**avni@globalseismology.org** or see our
[FAQs](http://avni.globalseismology.org/stable/overview/faq.html) for additional
clarifications.

## Acknowledgments

  * Funded by the [National Science Foundation](http://nsf.gov) and the
  [Computational Infrastructure for Geodynamics](http://geodynamics.org).
  * A project like this one is a culmination of feedback and input from several
  excellent [colleagues and
  organizations](https://globalseismology.princeton.edu/about/people). We thank
  members of the open source and Earth Science communities for their input and
  non-Github contributions.
  * Computational resources maintained by Princeton University accessible through
  the [AVNI website](http://avni.globalseismology.org). We thank the system
  administrators for assistance.

<img src="http://avni.globalseismology.org/stable/_static/logos/NSF.png"
width="100"> &nbsp; &nbsp; &nbsp; &nbsp; <img
src="http://avni.globalseismology.org/stable/_static/logos/CIG_logo.png"
width="200"> &nbsp; &nbsp; &nbsp; &nbsp; <img
src="http://avni.globalseismology.org/stable/_static/logos/PU-standard.png"
width="325">
